// 
// NTP connection for symbian by draven <riksa@medialab.sonera.fi>
// Do what ever you wish with these...
//
#ifndef _NTPConnection_H_
#define _NTPConnection_H_
#include <eikenv.h>
#include <e32base.h>
#include <es_sock.h>
#include <in_sock.h>

#include "connectioninit.h"

class CNTPConnection : public CActive
{
  public:
	IMPORT_C static CNTPConnection* NewL(MSocketObserver& aObserver);
	IMPORT_C virtual ~CNTPConnection();
	
	IMPORT_C void Sync();
	IMPORT_C void SetHost( TUint32 anAddr, TUint aPort );
  private:
  
	CNTPConnection(MSocketObserver& aObserver);
	void ConstructL();

	static TInt TimeOutCallBack(TAny* aPtr);
	void StartTimeoutTimer();
	void StopTimeoutTimer();

	void RunL();
	void DoCancel();
	
	CPeriodic *iTimeOutTimer;
	RSocketServ iSocketServ;
	RSocket 	iSocket;
	
	TUint8 iReply[1024];
	TPtr8 iReplyPtr;
	TInetAddr iReplyAddr;
	
	int iState;
	TInetAddr NTPHost;

	MSocketObserver& iObserver;
};

#endif