#include "break.h"

#include <e32base.h>
#include "app_context.h"
#include "app_context_impl.h"
#include "callstack.h"

EXPORT_C void BreakOnAllLeaves(void* aArg)
{
	TPtrC8* classname=(TPtrC8*)aArg;
	MApp_context* c;
	if (classname->Length()>0) {
		c=GetContext();
		if (classname->Compare(c->CallStackMgr().GetCurrentClass())!=0) {
			BreakInClassModule();
		}
	} else {
		BreakInClassModule();
	}
}
EXPORT_C void BreakInClassModule()
{
}

EXPORT_C void BreakInActiveObject()
{
}

EXPORT_C TBreakItem::TBreakItem(MApp_context* c) : iInClass(0, 0)
{ 
	if (c) { iInClass.Set(c->CallStackMgr().GetCurrentClass()); }
	CleanupStack::PushL(TCleanupItem(BreakOnAllLeaves, &iInClass));
}

EXPORT_C TBreakItem::~TBreakItem()
{
	CleanupStack::Pop();
}
