#!/usr/bin/perl


$prev_error=-1;
$run_i=0;

if ($#ARGV==4) {
	$type=pop(@ARGV);
}

$project=pop(@ARGV);
$build=shift @ARGV;
$platform=join(" ", @ARGV);

$done_makefile=0;
$force_rerun=0;
@cmds=();
$|=1;

while($run_i < 10) {
	$run_i++;
	if ( $#cmds == -1) {
		$cmd="abld.bat $build $platform $project";
		$force_rerun=0;
	} else {
		$c=shift @cmds;
		$cmd="abld.bat $c $platform $project";
		unless ($c eq "target") {
			$cmd =~ s/U(DEB|REL)//i;
		}
		if ($c eq "freeze") {
			print "***SLEEPING to ensure correct DEF file timestamp\n";
			sleep 2;
		}
	}
	if ($type eq "") { print "***RUNNING $cmd\n\n";}
	else { print "***RUNNING $cmd WITH PROJECTTYPE $type\n\n"; }

	open(RES, "$cmd 2>&1 |");
	$error=0;
	$def="";
	while(<RES>) {
		print $_;
		if ( / file.*(WINS|THUMB)' not found/ ) {
			$error=17;
		}
		if ( / No rule to.*THUMB'/ ) {
			$error=17;
		}
		if ( lc($type) eq "dll" && $build=~/target/i ) {
			if ($def eq "" && ( $error==4 || $error==2 || $error==14) ) {
				$def=$_;
				$def=~s/^ *([^ (]+)\(.*/$1/;
				$def=~s/^.*\\SYMBIAN/\\SYMBIAN/i;
				push(@defs, $def);
			}
			$error=15 if (/don't know how to.*DEF/);
			if (! $error ) {
				$error=2 if (/export.*not yet Froze/);
				$def="";
			}
			if (! $error ) {
				$error=3 if (/Not attempting to create/);
			}
			if ( /Ordinal not specified in sequence/) {
				$def=$_;
				$def=~s/^EFREEZE ERROR: //;
				$def=~s/^([^ (]+)\([0-9]+\) *: .*/$1/;
				$def=~s/^([^ ]+): .*/$1/;
				$def=~s/^.*\\SYMBIAN/\\SYMBIAN/i;
				push(@defs, $def);
				$error=4;
			}
			if (/missing from object files/) {
				$def="";
				$error=14;
			}
			if ( /When exports are frozen in/) {
				$def=$_;
				$def=~s/^[^"]*"//;
				$def=~s/".*$//;
				push(@defs, $def);
				$error=16;
			}
		}
		$error=1 if ($error<10 && $error != 4 && $error!=2 && /fatal error/i);
		$error=1 if ($error<10 && $error != 4 && $error!=2 && /^make.*Error/);
		$error=1 if ( /This project does not support/);
	}

	close(RES);
	if (!$force_rerun && $prev_error && $prev_error==$error) {
		print "LOGIC ERROR IN run_abld.pl!\n";
		exit 5;
	}
	$cmd="";
		
	$prev_error=$error;

	if ( ($#cmds==-1 && $error==0) || $error==1) {
		#print "***EXITING with status $error\n";
		exit $error;
	}

	if ($error==4 || $error==14) {
		foreach my $def (@defs) {
			print "***RESETING old DEFFILE $def\n";
			open(EXP, ">$def") || die "cannot open $def";
			print EXP "EXPORTS\n";
			close(EXP);
		}
		@cmds=();
		push(@cmds, "freeze");
		push(@cmds, "target");
		push(@cmds, "library");
	}
	if ($error==3 || $error==2) {
		@cmds=();
		push(@cmds, "freeze");
		push(@cmds, "target");
		push(@cmds, "library");
	}
	if ($error==17) {
		@cmds=();
		push(@cmds, "makefile");
		push(@cmds, "target");
	}
	if ($error==16) {
		@cmds=();
		print "***SLEEPING to ensure correct DEF file timestamp\n";
		sleep 2;
		foreach my $def (@defs) {
			print "***CREATING DEFFILE $def\n";
			open(EXP, ">$def") || die "cannot open $def";
			print EXP "EXPORTS\n";
			close(EXP);
		}
		push(@cmds, "makefile");
		push(@cmds, "target");
	}
}

print "***LOGIC ERROR in run_abld.pl: more than 10 iterations\n";
exit 2;
